# -------------------------------------------
# Called By: MINECRAFT
# File Name: tick
# File Purpose: Called every tick, serves as the main branch for all other functions
# Created By: Zaffre
# 
# Created On: 2025.01.22
# Last Modified On: 2025.02.26
# Last Modified By: Zaffre
#
# Credit to:
#
# Comments:
# -------------------------------------------

#execute as @a at @s[tag=!teleporting] if block ~ ~-0.1 ~ minecraft:reinforced_deepslate if entity @e[type=marker,tag=ancient_city_portal_core,tag=active,distance=..12] run tag @s[tag=!teleporting] add teleporting

#execute as @a at @s[tag=teleporting] if block ~ ~-0.1 ~ minecraft:reinforced_deepslate if entity @e[type=marker,tag=ancient_city_portal_core,tag=active,distance=..12] run tag @s[tag=teleporting] remove teleporting

execute as @a at @s[tag=!teleporting] if block ~ ~-0.1 ~ minecraft:reinforced_deepslate if entity @e[type=marker,tag=ancient_city_portal_core,tag=active,distance=..12] run tag @s[tag=!teleporting] add teleporting
execute as @a[tag=teleporting] at @s if entity @e[type=marker,tag=ancient_city_portal_core,tag=active,distance=..12] run function zaffre_structures:teleport


#Portal alignment assignment
execute as @e[type=marker,tag=ancient_city_portal_core,tag=!ns,tag=!ew,tag=igniting] at @s if block ~ ~ ~10.5 reinforced_deepslate run tag @s add ew
execute as @e[type=marker,tag=ancient_city_portal_core,tag=!ns,tag=!ew,tag=igniting] at @s if block ~10.5 ~ ~ reinforced_deepslate run tag @s add ns

#Portal activate detection
execute as @a[scores={city.portal.rclick=1..},nbt={SelectedItem:{components:{"minecraft:custom_data": {portal_key:1}}, id:"minecraft:carrot_on_a_stick"}}] at @s run playsound block.end_portal_frame.fill player @a ~ ~ ~ 0.5 1.2
execute as @a[scores={city.portal.rclick=1..},nbt={SelectedItem:{components:{"minecraft:custom_data": {portal_key:1}}, id:"minecraft:carrot_on_a_stick"}}] at @s run function zaffre_structures:portal_ignite


#Portal particle East/West
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:end_rod ^ ^3.4 ^ 0.2 0 5 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:end_rod ^ ^-2.4 ^ 0.2 0 5 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:end_rod ^ ^ ^10 0 2 0 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:end_rod ^ ^ ^-10 0 2 0 0.01 2 normal

execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^0.5 ^ 0.1 0 6 0.01 2 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-0.5 ^ 0.2 0 6 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-1.5 ^ 0.2 0 6 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^1.5 ^ 0.1 0 6 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^2.5 ^ 0.1 0 6 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ew] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-2.5 ^ 0.2 0 6 0.01 5 normal

#Portal particle North/South
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:end_rod ^ ^3.4 ^ 5 0 0.2 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:end_rod ^ ^-2.4 ^ 5 0 0.2 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:end_rod ^ ^ ^10 0 2 0 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:end_rod ^ ^ ^-10 0 2 0 0.01 2 normal

execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^0.5 ^ 6 0 0.1 0.01 2 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-0.5 ^ 6 0 0.2 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-1.5 ^ 6 0 0.2 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^1.5 ^ 6 0 0.1 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^2.5 ^ 6 0 0.1 0.01 5 normal
execute as @e[type=marker,tag=ancient_city_portal_core,tag=active,tag=ns] at @s run particle minecraft:trial_spawner_detection_ominous ^ ^-2.5 ^ 6 0 0.2 0.01 5 normal

#"Sprite" particles
execute as @e[type=bat,tag=city_portal_sprite] run particle minecraft:soul_fire_flame ^ ^ ^ 0.1 0.1 0.1 0.01 1

#Reset right-click detection
scoreboard players set @a city.portal.rclick 0